// +---------------------+
// | Event_onBrickLoaded |
// |  --Greek2me, 11902  |
// +---------------------+

registerInputEvent("fxDtsBrick","onBrickLoaded","Self fxDtsBrick" TAB "Player Player" TAB "Client GameConnection" TAB "Minigame Minigame");

package Event_onBrickLoaded
{
	function serverLoadSaveFile_Tick()
	{
		%parent = parent::serverLoadSaveFile_Tick();

		%localClient = findLocalClient();

		%count = $LoadingBricks_BrickGroup.getCount();
		%index = (%count - $FXBrick::ChainBatchSize < 0 ? 0 : %count - $FXBrick::ChainBatchSize);
		for(%i = %index; %i < %count; %i++)
		{
			%brick = $LoadingBricks_BrickGroup.getObject(%i);
			if(%brick.hasInputEvent("onBrickLoaded") && !isItemInList($Event_onBrickLoaded::BrickList,%brick))
			{
				$Event_onBrickLoaded::BrickList = setField($Event_onBrickLoaded::BrickList,getFieldCount($Event_onBrickLoaded::BrickList),%brick);
			}	
		}
		return %parent;
	}

	function serverLoadSaveFile_End()
	{
		%parent = parent::serverLoadSaveFile_End();

		%localClient = findLocalClient();
		%count = getFieldCount($Event_onBrickLoaded::BrickList);
		for(%i = 0; %i < %count; %i ++)
		{
			%brick = getField($Event_onBrickLoaded::BrickList,%i);

			%client = %brick.client;
			if(!isObject(%client))
			{
				%client = %localClient;
				if(!isObject(%client))
					continue;
			}

			$InputTarget_["Self"] = %brick;
			$InputTarget_["Player"] = %client.player;
			$InputTarget_["Client"] = %client;
			$InputTarget_["Minigame"] = getMinigameFromObject(%client);

			%brick.processInputEvent("onBrickLoaded",%client);
		}

		$Event_onBrickLoaded::BrickList = "";

		return %parent;
	}
};
activatePackage(Event_onBrickLoaded);

function fxDtsBrick::hasInputEvent(%this,%input)
{
	for(%i = 0; %i < %this.numEvents; %i ++)
	{
		if(%this.eventInput[%i] $= %input)
			return 1;
	}

	return 0;
}

function isItemInList(%list,%item)
{
	for(%i=0; %i < getFieldCount(%list); %i++)
	{
		if(getField(%list,%i) $= %item)
			return 1;
	}

	return 0;
}